<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<link href="/static/css/bootstrap.min.css" rel="stylesheet">
	<link href="/static/css/datepicker3.css" rel="stylesheet">
	<link href="/static/css/styles.css" rel="stylesheet">
	<link href="/static/css/bootstrap-table.css" rel="stylesheet">

	<!--[if lt IE 9]>
	<script src="/static/js/html5shiv.js"></script>
	<script src="/static/js/respond.min.js"></script>
	<![endif]-->
	<script src="/static/js/Chart.bundle.min.js"></script>
	<script src="https://api.mapy.cz/loader.js"></script>
	<script>
		if(typeof(Loader) != "undefined") Loader.load()
	</script>
	<title>AA4CC - Experiment</title>
</head>

<body>
	<nav class="navbar navbar-inverse navbar-fixed-top" role="navigation">
		<div class="container-fluid">
			<div class="navbar-header">
				<a class="navbar-brand" href="/"><span>AA4CC</span> Car ACC experiment - {{settings.id}}</a>
			</div>
							
		</div><!-- /.container-fluid -->
	</nav>
		
	<div class="main container-fluid">	
		{% with messages = get_flashed_messages() %}
		  {% if messages %}
		  	<div>
		  	
		    {% for message in messages %}
				<div class="alert alert-warning">
					{{ message }}
				</div>
		    {% endfor %}
		    </div>
		  {% endif %}
		{% endwith %}

		<div class="col-lg-6">
			<div class="row">
				<h3>Aktuální stav</h3>
				<table>
					<tr>
						<td>Datum a čas:</td>
						<td id="time" colspan="2">Nanačteno</td>
					</tr>
					<tr>
						<td style="width: 150px;">Pozice:</td>
						<td id="positionLat" style="width: 150px;">Nenačtena</td>
						<td id="positionLon" style="width: 150px;">Nenačtena</td>
						<td id="positionAcc" style="width: 150px;">&nbsp;</td>
					</tr>
					<tr>
						<td style="width: 150px;">Rychlost:</td>
						<td id="groundSpeed" style="width: 150px;">Nenačtena</td>
						<td id="groundSpeedAcc" style="width: 150px;">&nbsp;</td>
						<td id="groundSpeedKmh" style="width: 150px;">Nenačtena</td>

					</tr>
					<tr>
						<td>
							Relativní pozice:<br>
							(od vedoucího vozu)
						</td>
						<td>
							<span id="relposLength">&nbsp;</span><br>
							<span id="relposHeading">&nbsp;</span>
						</td>
						<td>
							<span id="relposLengthAcc">&nbsp;</span><br>
							<span id="relposHeadingAcc">&nbsp;</span>
						</td>
						<td>
							<span id="relposValid">&nbsp;</span>
						</td>
					</tr>
					<tr>
						<td>NTRIP Client</td>
						<td id="ntrip-host">Nenačteno</td>
						<td id="ntrip-mountpoint"></td>
						<td id="ntrip-bytes"></td>

					</tr>
					<tr>
						<td>NTRIP Caster</td>
						<td id="ntrip-caster-host">{{settings.ntrip_caster or "Neaktivní"}}</td>
						<td id="ntrip-caster-bytes"></td>

					</tr>
					{% if settings.get('ucenter_port', False) %}
					<tr>
						<td>Připojení k U-Center</td>
						<td id="connection"></td>
						<td colspan="2"><small>Pro připojení použijte cestu tcp://127.0.0.1:{{settings.get('ucenter_port', False)}}</small></td>
					</tr>
					{% endif %}
				</table>
			</div><!--/.row-->
			<div class="row">
				<h3>Pokyny</h3>
				{% if settings.get('master', False) %}
				<p id="instructions" style="height: 150px">
					Vyčkejte prosím na pokyny v tomto poli, nebo vysílačkou. Instrukce vysílačkou mají přednost!!
				</p>
				{% else %}
				<p id="instructions">
					Vyčkejte prosím na pokyny vysílačkou.
				</p>
				{% endif %}
				<canvas id="chart" style="width: 100%; height: 300px"></canvas>
			</div>
			<div class="row">
				<h3>Záznam dat</h3>
				<span>Stav: </span><span id="logging-state">Probíhá záznam</span><br/>
				<div class="input-group">
					<div class="input-group-btn">
						<button class="btn btn-success start-logging" type="submit">
							Zahájit záznam
						</button>
						<button class="btn btn-danger stop-logging" type="submit">
							Zastavit záznam
						</button>
						<button class="btn btn-primary make-point" type="submit">
							Vytvoř bod
						</button>
						<button class="btn btn-default open-map" type="submit">
							Aktivuj mapu
						</button>
					</div>
				</div>
			</div>
		</div>
		<div class="row">
			<div class="col-lg-6">
				<div id="mapa" style="width:100%; height:400px;"></div>
			</div>
		</div>
	</div>	<!--/.main-->

	<script src="/static/js/jquery-1.11.1.min.js"></script>
	<script src="/static/js/bootstrap.min.js"></script>	
	<script src="/static/js/bootstrap-table.js"></script>
	<script>
		var centering = 2

		!function ($) {
		    $(document).on("click","ul.nav li.parent > a > span.icon", function(){          
		        $(this).find('em:first').toggleClass("glyphicon-minus");      
		    }); 
		    $(".sidebar span.icon").find('em:first').addClass("glyphicon-plus");
		}(window.jQuery);

		$(window).on('resize', function () {
		  if ($(window).width() > 768) $('#sidebar-collapse').collapse('show')
		})
		$(window).on('resize', function () {
		  if ($(window).width() <= 767) $('#sidebar-collapse').collapse('hide')
		})

		window.mapa = undefined
		function createMap(){
			if(typeof(SMap) != "undefined"){
				var stred = SMap.Coords.fromWGS84(14.4176147, 50.0768546);
				window.mapa = new SMap(JAK.gel("mapa"), stred,18);
				mapa.addDefaultLayer(SMap.DEF_TURIST).enable();
				mapa.addDefaultControls();

				var layer = new SMap.Layer.Marker();
				mapa.addLayer(layer).enable();

				window.me = new SMap.Marker(stred, "myMarker", {title: "Já"});
				layer.addMarker(me);

				var sync = new SMap.Control.Sync({bottomSpace:30});
				mapa.addControl(sync);
			}
		}

		function load() {
			Loader.async = true;
			Loader.load(null, null, createMap);
		}

		function make_graph(){
			window.chartColors = {
				red: 'rgb(255, 99, 132)',
				orange: 'rgb(255, 159, 64)',
				yellow: 'rgb(255, 205, 86)',
				green: 'rgb(75, 192, 192)',
				blue: 'rgb(54, 162, 235)',
				purple: 'rgb(153, 102, 255)',
				grey: 'rgb(201, 203, 207)'
			};

			window.randomScalingFactor = function() {
				return Math.round(Math.random(-100, 100));
			};

			window.lineChartData = {
				labels: [],
				datasets: [{
					label: 'Rychlost [km/h]',
					borderColor: window.chartColors.red,
					backgroundColor: window.chartColors.red,
					fill: false,
					data: [],
					yAxisID: 'y-axis-1',
				}, {
					label: 'Odstup [m]',
					borderColor: window.chartColors.blue,
					backgroundColor: window.chartColors.blue,
					fill: false,
					data: [],
					yAxisID: 'y-axis-2'
				}]
			};


			var ctx = $('#chart');
			window.myChart = new Chart(ctx, {
				type: 'line',
				data: lineChartData,
				options: {
					responsive: true,
					hoverMode: 'index',
					stacked: false,
					title: {
						display: true,
						text: 'Krátká historie'
					},
					scales: {
						yAxes: [{
							type: 'linear', // only linear but allow scale type registration. This allows extensions to exist solely for log scale for instance
							display: true,
							position: 'left',
							id: 'y-axis-1',
							scaleLabel: {
								display: true,
								labelString: "km/h"
							},
							ticks:{
								min: 0,
								max: 120
							}
						}, {
							type: 'linear', // only linear but allow scale type registration. This allows extensions to exist solely for log scale for instance
							display: true,
							position: 'right',
							id: 'y-axis-2',
							scaleLabel: {
								display: true,
								labelString: "m"
							},
							ticks:{
								min: 0
							},

							// grid line settings
							gridLines: {
								drawOnChartArea: false, // only want the grid lines for one axis to show up
							},
						}],
					}
				}
			}	);
		}

		function convertDate(d){
			hours = d.getHours()
			if(hours < 10) hours = "0"+hours
			minutes = d.getMinutes()
			if(minutes < 10) minutes = "0"+minutes
			seconds = d.getSeconds()
			if(seconds < 10) seconds = "0"+seconds
			return hours+":"+minutes+":"+seconds+"."+d.getMilliseconds()/100
		}

		function useData(event){
			// console.log(event)
			// return
			json = JSON.parse(event.data)
			//console.log(json)
			if(typeof(window.mapa) != "undefined"){
				var position = SMap.Coords.fromWGS84(json.position.longitude, json.position.latitude);
				window.position = position
				me.setCoords(position)
				
				switch(centering){
					case 1: if(!position.inMap(mapa)) mapa.setCenter(position); break
					case 2: mapa.setCenter(position)
				}
			}

			$('#time').text(json.time)
			$('#positionLat').text((json.position.latitude>0?'N':'S')+Math.abs(json.position.latitude))
			$('#positionLon').text((json.position.longitude>0?'E':'W')+Math.abs(json.position.longitude))
			$('#positionAcc').text('(± '+json.position.accuracy+' m)')
			$('#groundSpeed').text(json.position.groundSpeed+' m/s')
			$('#groundSpeedAcc').text('(± '+json.position.groundSpeedAcurracy+' m/s)')
			$('#groundSpeedKmh').text(Math.round(json.position.groundSpeed*3.6)+' km/h')
			$('#relposLength').text(json.relative_position.Length+' m')
			$('#relposLengthAcc').text('(± '+json.relative_position.LengthAcc+')')
			$('#relposHeading').text(json.relative_position.Heading+'°')
			$('#relposHeadingAcc').text('(± '+json.relative_position.HeadingAcc+')')
			$('#relposValid').text(json.relative_position.Valid?"Platná":"Není k dispozici")
			$('#connection').text(json['u-center']?'Aktivní':'Neaktivní')

			if(json.ntrip.enabled){
				$('#ntrip-host').text(json.ntrip.host)
				$('#ntrip-mountpoint').text(json.ntrip.mountpoint)
				$('#ntrip-bytes').text(Math.round(json.ntrip.in_bytes/1024)+' kB')
			}else{
				$('#ntrip-host').text('Neaktivní')
				$('#ntrip-mountpoint').text('')
				$('#ntrip-bytes').text('')
			}

			if(json.ntrip_caster.active){
				$('#ntrip-caster-bytes').text(Math.round(json.ntrip_caster.sent/1024)+' kB')
			}else{
				$('#ntrip-caster-bytes').text('')
			}

			if(json.logging.active){
				$("#logging-state").text("Probíhá záznam do souboru \""+json.logging.filename+"\" ("+Math.round(json.logging.file_bytes/1024)+" kB)")
			}else{
				$("#logging-state").text("Záznam zastaven")
			}

			if((typeof(lastData)=="undefined") || (json.time != lastData.time)){
				if(lineChartData.labels.length > 100) lineChartData.labels.shift(0)
				if(lineChartData.datasets[0].data.length > 100) lineChartData.datasets[0].data.shift()
				if(lineChartData.datasets[1].data.length > 100) lineChartData.datasets[1].data.shift()

				lineChartData.labels.push(convertDate(new Date(json.time)))
				lineChartData.datasets[0].data.push(json.position.groundSpeed*3.6)
				lineChartData.datasets[1].data.push(json.relative_position.Length)
				myChart.update()
			}

			window.lastData = json
		}

		$(function(){
			var sse = new EventSource('/stream')
			sse.addEventListener('open', function (){
				console.log("Live connection")
			})
			sse.addEventListener('message', useData)

			{% if settings.get('master', False) %}
			var master = new EventSource('http://{{settings.get('master')}}/instructions')
			master.addEventListener('open', function (){
				console.log("Master connection")
			})
			master.addEventListener('message', function(event){
				if(event.data.length) $("#instructions").text(event.data)
				else $("#instructions").text("Vyčkejte prosím na pokyny v tomto poli, nebo vysílačkou. Instrukce vysílačkou mají přednost!!")
            })
			{% endif %}

			$('.start-logging').click(function(){
				$.get("log/open").fail(function(data){
					alert('Error: '+data.responseText)
				})
			})

			$('.stop-logging').click(function(){
				$.get("log/close")
				.fail(function(data){
					alert('Error: '+data.responseText)
				})
			}),

			$('.make-point').click(function(){
				$.get("make_point")
				.fail(function(data){
					alert('Error: '+data.responseText)
				})
			})

			$('.open-map').click(load)

			make_graph()
		})
	</script>	
</body>

</html>
